<?php

/**
 * @category  Shopware
 * @package   Shopware\Plugins\rapi1RapidExtendApi
 */
class Shopware_Plugins_Core_rapi1RapidExtendApi_Bootstrap extends Shopware_Components_Plugin_Bootstrap {

    /**
     * Get plugin capabilities
     *
     * @return array
     */
    public function getCapabilities() {

        return array(
            'install' => true,
            'update' => true,
            'enable' => true
        );

    }

    /**
     * Get plugin label
     *
     * @return string
     */
    public function getLabel() {
        return 'Rapidmail newsletter recipient plug-in';
    }

    /**
     * Get plugin version
     *
     * @return string
     */
    public function getVersion() {
        return '2.0.2';
    }

    /**
     * Informations about plugin.
     *
     * @return array
     */
    public function getInfo() {

        return array(
            'version' => $this->getVersion(),
            'label' => $this->getLabel(),
            'author' => 'rapidmail GmbH',
            'copyright' => 'Copyright © ' . date('Y') . ', rapidmail GmbH',
            'supplier' => 'rapidmail GmbH',
            'description' => 'Get newsletter recipients plugin',
            'link' => 'http://www.rapidmail.de'
        );

    }

    /**
     * @return bool
     */
    public function install() {

        $this->subscribeEvents();

        return true;

    }

    /**
     * Registers all necessary events and hooks.
     */
    private function subscribeEvents() {

        $this->subscribeEvent(
            'Enlight_Controller_Front_StartDispatch',
            'onEnlightControllerFrontStartDispatch'
        );

        $this->subscribeEvent(
            'Enlight_Controller_Dispatcher_ControllerPath_Api_Recipients',
            'onGetRecipientsApiController'
        );

    }

    /**
     * Sets
     *
     * @param Enlight_Event_EventArgs $args
     */
    public function onEnlightControllerFrontStartDispatch(Enlight_Event_EventArgs $args) {

        $this->Application()->Loader()->registerNamespace(
            'Shopware\Components',
            $this->Path() . 'Components/'
        );

    }

    /**
     * Gets recipients controller path
     *
     * @return string
     */
    public function onGetRecipientsApiController() {
        return $this->Path() . 'Controllers/Api/Recipients.php';
    }

}
