<?php

class Shopware_Controllers_Api_Recipients extends Shopware_Controllers_Api_Rest
{
    /**
     * @var Shopware\Components\Api\Resource\Recipient
     */
    protected $resource = null;

    /**
     * Init resource call
     */
    public function init() {
        $this->resource = \Shopware\Components\Api\Manager::getResource('Recipient');
    }

    /**
     * Get list of newsletter subscribers
     * or subscribers count
     *
     * GET /api/recipients/
     */
    public function indexAction() {

        $count = $this->Request()->getParam('count', false);
        $offset = $this->Request()->getParam('start', 0);
        $limit = $this->Request()->getParam('limit', 100);

        if ($count) {
            $result = $this->resource->getRecipientsCount();
        } else {
            $result = $this->resource->getRecipients($offset, $limit);
        }

        $this->View()->assign($result);
        $this->View()->assign('success', true);

    }

    /**
     * Test connection
     *
     * GET /api/recipients/test/
     */
    public function getAction() {
        $this->View()->assign('success', true);
    }

}
